Bug 886900 - Review Request: arm-none-eabi-binutils-cs - GNU Binutils for cross-compilation for ARM target
Review Request: arm-none-eabi-binutils-cs - GNU Binutils for cross-compilatio...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tomáš Hozza
Fedora Extras Quality Assurance
:
: 639661 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-12-13 09:31 EST by Michal Hlavinka
Modified: 2013-02-20 11:54 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-20 11:54:06 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
thozza: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Michal Hlavinka 2012-12-13 09:31:35 EST
Spec URL: http://mihlit.cz/smetiste/arm-none-eabi-binutils-cs.spec
SRPM URL: http://mihlit.cz/smetiste/arm-none-eabi-binutils-cs-2012.09.63-1.fc17.src.rpm
Description: 
This is a cross-compilation version of GNU Binutils, which can be used to
assemble and link binaries for the %{target} platform.

This Binutils package is based on the CodeSourcery
%{cs_date}-%{cs_rel} release, which includes improved ARM target
support compared to the corresponding FSF release.  CodeSourcery
contributes their changes to the FSF, but it takes a while for them to
get merged.  For the ARM target, effectively CodeSourcery is upstream
of FSF.

Fedora Account System Username: mhlavink

Note: This is targeted for bare-metal arm development (st's STM32xxxx, atmel's SAMxxxx and similar microcontrollers - like avr. For linux on arm, there is cross-{binutils,gcc}-arm).
Comment 1 Michal Hlavinka 2012-12-13 09:32:14 EST
rpmlint is not silent:
1) macros in comments - these are just plain strings used is commented-out URLs, so no ugly macros with side-effects
2) Source0 is not in an URL form, because original tarball has 147 MB and contains just several tarballs - we need just one of them. So, to save space, Source0 is just that tarball and there is comment how and where to obtain it.
Comment 2 Michal Hlavinka 2012-12-13 09:32:21 EST
*** Bug 639661 has been marked as a duplicate of this bug. ***
Comment 3 Tomáš Hozza 2013-02-19 04:05:06 EST
Please update SRPM to contain the same SPEC file you have listed in Spec URL.

Thank you.

Diff spec file in url and in SRPM
---------------------------------
--- /home/thozza/tmp/886900-arm-none-eabi-binutils-cs/srpm/arm-none-eabi-binutils-cs.spec	2013-02-18 16:11:54.169586124 +0100
+++ /home/thozza/tmp/886900-arm-none-eabi-binutils-cs/srpm-unpacked/arm-none-eabi-binutils-cs.spec	2013-02-18 16:11:54.338586420 +0100
@@ -1,2 +1,7 @@
+# The following three variables define the target tuple
+%global processor_arch arm
+%global platform       none
+%global abi            eabi
+
 # CodeSourcery releases are identified by a date, a release number,
 # and a package number for downloading from their web site
@@ -5,6 +10,5 @@
 %global cs_pkgnum      10925
 
-%global processor_arch arm
-%global target         %{processor_arch}-none-eabi
+%global target         %{processor_arch}-%{platform}-%{abi}
 
 Name:           %{target}-binutils-cs
@@ -19,6 +23,6 @@
 Source0:        binutils-%{cs_date}-%{cs_rel}.tar.bz2
 #Source0 origin:
-#wget https://sourcery.mentor.com/GNUToolchain/package%{cs_pkgnum}/public/%{target}/%{processor_arch}-%{cs_date}-%{cs_rel}-%{target}.src.tar.bz2
-#tar jxvf %{processor_arch}-%{cs_date}-%{cs_rel}-%{target}.src.tar.bz2
+#wget https://sourcery.mentor.com/GNUToolchain/package%{cs_pkgnum}/public/%{target}/%{processor_arg}-%{cs_date}-%{cs_rel}-%{target}.src.tar.bz2
+#tar jxvf %{processor_arg}-%{cs_date}-%{cs_rel}-%{target}.src.tar.bz2
 
 Source1:        README.fedora
Comment 4 Michal Hlavinka 2013-02-19 04:32:01 EST
(In reply to comment #3)
> Please update SRPM to contain the same SPEC file you have listed in Spec URL.

done
Comment 5 Tomáš Hozza 2013-02-19 10:21:42 EST
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated


===== MUST items =====

C/C++:
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.<F2>
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
     - Not an issue!
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
     - With some exceptions because this is a cross-compiler package.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (binutils-2012.09-63.tar.bz2) Source1 (README.fedora)
     - Not an issue. Source0 is just a part of upstream tarball. It is
     unnecessary to rename it.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: arm-none-eabi-binutils-cs-2012.09.63-1.fc17.x86_64.rpm
          arm-none-eabi-binutils-cs-debuginfo-2012.09.63-1.fc17.x86_64.rpm
          arm-none-eabi-binutils-cs-2012.09.63-1.fc17.src.rpm
arm-none-eabi-binutils-cs.x86_64: W: incoherent-version-in-changelog 2012.09_63-1 ['2012.09.63-1.fc17', '2012.09.63-1']
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/bin/arm-none-eabi-ar /usr/arm-none-eabi/bin/ar
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/bin/arm-none-eabi-as /usr/arm-none-eabi/bin/as
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/ld.bfd /usr/bin/arm-none-eabi-ld
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/bin/arm-none-eabi-ld.bfd /usr/arm-none-eabi/bin/ld.bfd
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/objdump /usr/bin/arm-none-eabi-objdump
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/objcopy /usr/bin/arm-none-eabi-objcopy
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/bin/arm-none-eabi-strip /usr/arm-none-eabi/bin/strip
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/ld /usr/bin/arm-none-eabi-ld.bfd
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/ranlib /usr/bin/arm-none-eabi-ranlib
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/nm /usr/bin/arm-none-eabi-nm
arm-none-eabi-binutils-cs.x86_64: W: no-manual-page-for-binary arm-none-eabi-ld.bfd
arm-none-eabi-binutils-cs.x86_64: W: non-standard-dir-in-usr arm-none-eabi
arm-none-eabi-binutils-cs-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/binutils-2012.09/bfd/elf-nacl.h
arm-none-eabi-binutils-cs-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/binutils-2012.09/bfd/elf-nacl.c
arm-none-eabi-binutils-cs-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/binutils-2012.09/bfd/elf-vxworks.c
arm-none-eabi-binutils-cs-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/binutils-2012.09/bfd/elf-vxworks.h
- Please notify upstream about this issue. Anyway this is not preventing this package to be approved.

arm-none-eabi-binutils-cs-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/binutils-2012.09/include/elf/epiphany.h
arm-none-eabi-binutils-cs.src:21: W: macro-in-comment %{cs_pkgnum}
arm-none-eabi-binutils-cs.src:21: W: macro-in-comment %{target}
arm-none-eabi-binutils-cs.src:21: W: macro-in-comment %{processor_arch}
arm-none-eabi-binutils-cs.src:21: W: macro-in-comment %{cs_date}
arm-none-eabi-binutils-cs.src:21: W: macro-in-comment %{cs_rel}
arm-none-eabi-binutils-cs.src:21: W: macro-in-comment %{target}
arm-none-eabi-binutils-cs.src:22: W: macro-in-comment %{processor_arch}
arm-none-eabi-binutils-cs.src:22: W: macro-in-comment %{cs_date}
arm-none-eabi-binutils-cs.src:22: W: macro-in-comment %{cs_rel}
arm-none-eabi-binutils-cs.src:22: W: macro-in-comment %{target}
arm-none-eabi-binutils-cs.src: W: invalid-url Source0: binutils-2012.09-63.tar.bz2
3 packages and 0 specfiles checked; 4 errors, 25 warnings.

- Warnings are commented and explained in Comment #1.


Rpmlint (installed packages)
----------------------------
# rpmlint arm-none-eabi-binutils-cs-debuginfo arm-none-eabi-binutils-cs
arm-none-eabi-binutils-cs-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/binutils-2012.09/bfd/elf-nacl.h
arm-none-eabi-binutils-cs-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/binutils-2012.09/bfd/elf-nacl.c
arm-none-eabi-binutils-cs-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/binutils-2012.09/bfd/elf-vxworks.c
arm-none-eabi-binutils-cs-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/binutils-2012.09/bfd/elf-vxworks.h
arm-none-eabi-binutils-cs-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/binutils-2012.09/include/elf/epiphany.h
arm-none-eabi-binutils-cs.x86_64: W: incoherent-version-in-changelog 2012.09_63-1 ['2012.09.63-1.fc17', '2012.09.63-1']
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/bin/arm-none-eabi-ar /usr/arm-none-eabi/bin/ar
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/bin/arm-none-eabi-as /usr/arm-none-eabi/bin/as
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/ld.bfd /usr/bin/arm-none-eabi-ld
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/bin/arm-none-eabi-ld.bfd /usr/arm-none-eabi/bin/ld.bfd
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/objdump /usr/bin/arm-none-eabi-objdump
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/objcopy /usr/bin/arm-none-eabi-objcopy
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/bin/arm-none-eabi-strip /usr/arm-none-eabi/bin/strip
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/ld /usr/bin/arm-none-eabi-ld.bfd
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/ranlib /usr/bin/arm-none-eabi-ranlib
arm-none-eabi-binutils-cs.x86_64: W: cross-directory-hard-link /usr/arm-none-eabi/bin/nm /usr/bin/arm-none-eabi-nm
arm-none-eabi-binutils-cs.x86_64: W: no-manual-page-for-binary arm-none-eabi-ld.bfd
arm-none-eabi-binutils-cs.x86_64: W: non-standard-dir-in-usr arm-none-eabi
2 packages and 0 specfiles checked; 4 errors, 14 warnings.
# echo 'rpmlint-done:'



Requires
--------
arm-none-eabi-binutils-cs-2012.09.63-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libm.so.6()(64bit)
    rtld(GNU_HASH)

arm-none-eabi-binutils-cs-debuginfo-2012.09.63-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    

Provides
--------
arm-none-eabi-binutils-cs-2012.09.63-1.fc17.x86_64.rpm:
    
    arm-none-eabi-binutils-cs = 2012.09.63-1.fc17
    arm-none-eabi-binutils-cs(x86-64) = 2012.09.63-1.fc17

arm-none-eabi-binutils-cs-debuginfo-2012.09.63-1.fc17.x86_64.rpm:
    
    arm-none-eabi-binutils-cs-debuginfo = 2012.09.63-1.fc17
    arm-none-eabi-binutils-cs-debuginfo(x86-64) = 2012.09.63-1.fc17


Everything looks good. This package HAS BEEN APPROVED!
Comment 6 Michal Hlavinka 2013-02-19 10:43:18 EST
Thanks for the review.

New Package SCM Request
=======================
Package Name: arm-none-eabi-binutils-cs
Short Description: GNU Binutils for cross-compilation for arm-none-eabi target
Owners: mhlavink
Branches: f17 f18
InitialCC:
Comment 7 Gwyn Ciesla 2013-02-19 13:39:12 EST
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.